/* Copyright Siemens, 2023 */


#ifndef VSOMEIP_V3_MESSAGE_HEADER_HPP
#define VSOMEIP_V3_MESSAGE_HEADER_HPP

#include <vsomeip/export.hpp>
#include <vsomeip/primitive_types.hpp>
#include <vsomeip/enumeration_types.hpp>
#include <vsomeip/internal/serializable.hpp>
#include <vsomeip/internal/deserializable.hpp>

namespace vsomeip_v3 {

class message_base;

class message_header: public serializable,
public deserializable {
public:
    message_header();
    message_header(const message_header &_header);
    VSOMEIP_EXPORT virtual message_base * get_owner() const;
    VSOMEIP_EXPORT virtual void set_owner(message_base *_owner);

    service_t service_;
    method_t method_;
    length_t length_;
    client_t client_;
    session_t session_;
    protocol_version_t protocol_version_;
    interface_version_t interface_version_;
    message_type_e type_;
    return_code_e code_;

    instance_t instance_;
    message_base *owner_;
};

} // namespace vsomeip_v3


#endif // VSOMEIP_V3_MESSAGE_HEADER_IMPL_HPP
