/* Copyright Siemens, 2023 */

#include "../include/message_header.hpp"

namespace vsomeip_v3 {

message_header::message_header()
    : service_(0x0), method_(0x0), length_(0x0),
      client_(0x0), session_(0x0),
      protocol_version_(0x1), interface_version_(0x0),
      type_(message_type_e::MT_UNKNOWN),
      code_(return_code_e::E_UNKNOWN),
      instance_(0x0), owner_(0x0) {
}

message_base * message_header::get_owner() const {
    return owner_;
}

void message_header::set_owner(message_base *_owner) {
    owner_ = _owner;
}

} // namespace vsomeip_v3