/* Copyright Siemens, 2023 */

#include "../include/serializer.hpp"
#include "../include/deserializer.hpp"
#include "../include/message_base_impl.hpp"
#include "../include/signalbased_message_header_impl.hpp"

namespace vsomeip_v3 {

signalbased_message_header_impl::signalbased_message_header_impl()
{
    type_ = message_type_e::MT_NOTIFICATION;
}

bool signalbased_message_header_impl::serialize(serializer *_to) const {
    return (0 != _to
            && _to->serialize(service_)
            && _to->serialize(method_)
            && _to->serialize(owner_->get_length()));
}

bool signalbased_message_header_impl::deserialize(deserializer *_from) {
    bool is_successful;

    is_successful = (0 != _from
            && _from->deserialize(service_)
            && _from->deserialize(method_)
            && _from->deserialize(length_));

    return is_successful;
}

} // namespace vsomeip_v3
