#!/bin/sh

# Copyright Siemens, 2023

FAIL=0

export VSOMEIP_CONFIGURATION=signal_based_test.json

cat <<End-of-message
*******************************************************************************
*******************************************************************************
** 1- run routingmanagerd so the next applications will act as proxies
*******************************************************************************
*******************************************************************************
End-of-message
../examples/routingmanagerd/./routingmanagerd &
DAEMON_PID=$!

cat <<End-of-message
*******************************************************************************
*******************************************************************************
** 2- run the server application
*******************************************************************************
*******************************************************************************
End-of-message
./signal_based_server UDP &

cat <<End-of-message
*******************************************************************************
*******************************************************************************
** 3- run the test application acts as a client
*******************************************************************************
*******************************************************************************
End-of-message
./signal_based_test UDP &
PID_CLIENT=$!


# wait until client exits successfully
wait $PID_CLIENT || FAIL=$(($FAIL+1))

# kill daemon
kill $DAEMON_PID
wait $DAEMON_PID || FAIL=$(($FAIL+1))

# Check if both exited successfully 
if [ $FAIL -eq 0 ]; then
    exit 0
else
    exit 1
fi
