#!/bin/bash

# Copyright Siemens, 2023

FAIL=0

RELIABILITY_TYPE=$1

cat <<End-of-message
*******************************************************************************
*******************************************************************************
1.start client first
*******************************************************************************
*******************************************************************************
End-of-message
    docker exec $INNER_DOCKER_NAME sh -c "export LD_LIBRARY_PATH=/tool/boost_1_74_0/lib:$DOCKER_TESTS/.. && cd $DOCKER_TESTS && ./signal_based_test_client_start.sh $RELIABILITY_TYPE" &

sleep 4

cat <<End-of-message
*******************************************************************************
*******************************************************************************
start remote scenario
*******************************************************************************
*******************************************************************************
End-of-message
./signal_based_test_server_start.sh $RELIABILITY_TYPE &

# Wait until client and service are finished
for job in $(jobs -p)
do
    # Fail gets incremented if either client or service exit
    # with a non-zero exit code
    wait $job || ((FAIL+=1))
done

# Check if client and server both exited successfully
if [ $FAIL -eq 0 ]
then
    exit 0
else
    exit 1
fi
